4 # close stdin, as with ubuntu and debian VMs this script tends to hang and wait for input ..
13 # pkgs parsing utilities
14 export PATH=$(dirname $0):$PATH
16 # old guests have e.g. mount in /bin but this is no longer part of
17 # the standard PATH in recent hosts after usrmove, so let's keep it simple
18 export PATH=$PATH:/bin:/sbin
24 DEFAULT_PERSONALITY=linux64
30 # the network interface name as seen from the container
34 FEDORA_PREINSTALLED="yum initscripts passwd rsyslog vim-minimal dhclient chkconfig rootfiles policycoreutils openssh-server openssh-clients"
35 DEBIAN_PREINSTALLED="openssh-server openssh-client"
37 ##############################
38 ## stolen from tests/system/template-qemu/qemu-bridge-init
39 # use /proc/net/dev instead of a hard-wired list
40 function gather_interfaces () {
42 for line in file("/proc/net/dev"):
43 if ':' not in line: continue
44 ifname=line.replace(" ","").split(":")[0]
45 if ifname.find("lo")==0: continue
46 if ifname.find("br")==0: continue
47 if ifname.find("virbr")==0: continue
48 if ifname.find("veth")==0: continue
49 if ifname.find("tap")==0: continue
54 function discover_interface () {
55 for ifname in $(gather_interfaces); do
56 ip link show $ifname | grep -qi 'state UP' && { echo $ifname; return; }
58 # still not found ? that's bad
62 ########## networking -- ctd
63 function gethostbyname () {
65 python -c "import socket; print socket.gethostbyname('"$hostname"')" 2> /dev/null
68 # e.g. 21 -> 255.255.248.0
69 function masklen_to_netmask () {
74 if not (masklen>=1 and masklen<=32):
75 print "Wrong masklen",masklen
83 result.append(masklen)
85 print ".".join([ str(256-2**(8-i)) for i in result ])
90 #################### bridge initialization
91 function create_bridge_if_needed() {
96 # already created ? - we're done
97 ip addr show $PUBLIC_BRIDGE >& /dev/null && {
98 echo "Bridge already set up - skipping create_bridge_if_needed"
102 # find out the physical interface to bridge onto
103 if_lan=$(discover_interface)
105 ip addr show $if_lan &>/dev/null || {
106 echo "Cannot use interface $if_lan - exiting"
110 #################### bride initialization
111 check_yum_installed bridge-utils
113 echo "========== $COMMAND: entering create_bridge - beg"
118 echo "========== $COMMAND: entering create_bridge - end"
120 # disable netfilter calls for bridge interface (they cause panick on 2.6.35 anyway)
122 # another option would be to accept the all forward packages for
123 # bridged interface like: -A FORWARD -m physdev --physdev-is-bridged -j ACCEPT
124 sysctl net.bridge.bridge-nf-call-iptables=0
125 sysctl net.bridge.bridge-nf-call-ip6tables=0
126 sysctl net.bridge.bridge-nf-call-arptables=0
129 #Getting host IP/masklen
130 address=$(ip addr show $if_lan | grep -v inet6 | grep inet | head --lines=1 | awk '{print $2;}')
131 [ -z "$address" ] && { echo "ERROR: Could not determine IP address for $if_lan" ; exit 1 ; }
133 broadcast=$(ip addr show $if_lan | grep -v inet6 | grep inet | head --lines=1 | awk '{print $4;}')
134 [ -z "$broadcast" ] && echo "WARNING: Could not determine broadcast address for $if_lan"
136 gateway=$(ip route show | grep default | awk '{print $3;}')
137 [ -z "$gateway" ] && echo "WARNING: Could not determine gateway IP"
140 # creating the bridge
141 echo "Creating bridge PUBLIC_BRIDGE=$PUBLIC_BRIDGE"
142 brctl addbr $PUBLIC_BRIDGE
143 brctl addif $PUBLIC_BRIDGE $if_lan
144 echo "Activating promiscuous mode if_lan=$if_lan"
145 ip link set $if_lan up promisc on
147 # rely on dhcp to re assign IP..
148 echo "Starting dhclient on $PUBLIC_BRIDGE"
149 dhclient $PUBLIC_BRIDGE
152 #Reconfigure the routing table
153 echo "Configuring gateway=$gateway"
154 ip route add default via $gateway dev $PUBLIC_BRIDGE
155 ip route del default via $gateway dev $if_lan
156 # at this point we have an extra route like e.g.
158 #default via 138.96.112.250 dev br0
159 #138.96.112.0/21 dev em1 proto kernel scope link src 138.96.112.57
160 #138.96.112.0/21 dev br0 proto kernel scope link src 138.96.112.57
161 #192.168.122.0/24 dev virbr0 proto kernel scope link src 192.168.122.1
162 route_dest=$(ip route show | grep -v default | grep "dev $PUBLIC_BRIDGE" | awk '{print $1;}')
163 ip route del $route_dest dev $if_lan
165 echo "========== $COMMAND: exiting create_bridge - beg"
168 echo "========== $COMMAND: exiting create_bridge - end"
176 ##############################
177 # return yum or debootstrap
178 function package_method () {
181 f[0-9]*|centos[0-9]*|sl[0-9]*) echo yum ;;
182 squeeze|wheezy|jessie|oneiric|precise|quantal|raring|saucy) echo debootstrap ;;
183 *) echo Unknown distro $fcdistro ;;
187 # return arch from debian distro and personality
188 function canonical_arch () {
189 personality=$1; shift
191 case $(package_method $fcdistro) in
193 case $personality in *32) echo i386 ;; *64) echo x86_64 ;; *) echo Unknown-arch-1 ;; esac ;;
195 case $personality in *32) echo i386 ;; *64) echo amd64 ;; *) echo Unknown-arch-2 ;; esac ;;
197 echo Unknown-arch-3 ;;
201 # the new test framework creates /timestamp in /vservers/<name> *before* populating it
202 function almost_empty () {
204 # non existing is fine
205 [ ! -d $dir ] && return 0;
206 # need to have at most one file
207 count=$(cd $dir; ls | wc -l); [ $count -le 1 ];
210 ##############################
211 function check_yum_installed () {
213 rpm -q $package >& /dev/null || yum -y install $package
216 function check_yumgroup_installed () {
218 yum grouplist "$group" | grep -q Installed || { yum -y groupinstall "$group" ; }
221 ##############################
222 function fedora_install() {
226 cache=/var/cache/lxc/fedora/$arch/$release
228 mkdir -p /var/lock/subsys/
230 flock -n -x 200 || { echo "Cache repository is busy." ; return 1 ; }
232 if [ ! -e "$cache/rootfs" ]; then
233 echo "Getting cache download in $cache/rootfs ... "
234 fedora_download || { echo "Failed to download 'fedora base'"; return 1; }
236 echo "Updating cache $cache/rootfs ..."
237 if ! yum --installroot $cache/rootfs -y --nogpgcheck update ; then
238 echo "Failed to update 'fedora base', continuing with last known good cache"
240 echo "Update finished"
244 echo "Copy $cache/rootfs to $lxc_root ... "
245 rsync -a $cache/rootfs/ $lxc_root/
249 ) 200>/var/lock/subsys/lxc
254 function fedora_download() {
256 # check the mini fedora was not already downloaded
257 INSTALL_ROOT=$cache/partial
260 # download a mini fedora into a cache
261 echo "Downloading fedora minimal ..."
263 mkdir -p $INSTALL_ROOT || { echo "Failed to create '$INSTALL_ROOT' directory" ; return 1; }
265 mkdir -p $INSTALL_ROOT/etc/yum.repos.d
266 mkdir -p $INSTALL_ROOT/dev
267 mknod -m 0444 $INSTALL_ROOT/dev/random c 1 8
268 mknod -m 0444 $INSTALL_ROOT/dev/urandom c 1 9
270 # copy yum config and repo files
271 cp /etc/yum.conf $INSTALL_ROOT/etc/
272 cp /etc/yum.repos.d/fedora* $INSTALL_ROOT/etc/yum.repos.d/
274 # append fedora repo files with desired $release and $basearch
275 for f in $INSTALL_ROOT/etc/yum.repos.d/* ; do
276 sed -i "s/\$basearch/$arch/g; s/\$releasever/$release/g;" $f
279 MIRROR_URL=http://mirror.onelab.eu/fedora/releases/$release/Everything/$arch/os
280 RELEASE_URL1="$MIRROR_URL/Packages/fedora-release-$release-1.noarch.rpm"
281 # with fedora18 the rpms are scattered by first name
282 RELEASE_URL2="$MIRROR_URL/Packages/f/fedora-release-$release-1.noarch.rpm"
283 RELEASE_TARGET=$INSTALL_ROOT/fedora-release-$release.noarch.rpm
285 for attempt in $RELEASE_URL1 $RELEASE_URL2; do
286 if curl -f $attempt -o $RELEASE_TARGET ; then
287 echo "Retrieved $attempt"
291 echo "Failed attempt $attempt"
294 [ -n "$found" ] || { echo "Could not retrieve fedora-release rpm - exiting" ; exit 1; }
296 mkdir -p $INSTALL_ROOT/var/lib/rpm
297 rpm --root $INSTALL_ROOT --initdb
298 # when installing f12 this apparently is already present, so ignore result
299 rpm --root $INSTALL_ROOT -ivh $INSTALL_ROOT/fedora-release-$release.noarch.rpm || :
300 # however f12 root images won't get created on a f18 host
301 # (the issue here is the same as the one we ran into when dealing with a vs-box)
302 # in a nutshell, in f12 the glibc-common and filesystem rpms have an apparent conflict
303 # >>> file /usr/lib/locale from install of glibc-common-2.11.2-3.x86_64 conflicts
304 # with file from package filesystem-2.4.30-2.fc12.x86_64
305 # in fact this was - of course - allowed by f12's rpm but later on a fix was made
306 # http://rpm.org/gitweb?p=rpm.git;a=commitdiff;h=cf1095648194104a81a58abead05974a5bfa3b9a
307 # So ideally if we want to be able to build f12 images from f18 we need an rpm that has
308 # this patch undone, like we have in place on our f14 boxes (our f14 boxes need a f18-like rpm)
310 YUM="yum --installroot=$INSTALL_ROOT --nogpgcheck -y"
311 echo "$YUM install $FEDORA_PREINSTALLED"
312 $YUM install $FEDORA_PREINSTALLED || { echo "Failed to download rootfs, aborting." ; return 1; }
314 mv "$INSTALL_ROOT" "$cache/rootfs"
315 echo "Download complete."
320 ##############################
321 function fedora_configure() {
326 # disable selinux in fedora
327 mkdir -p $lxc_root/selinux
328 echo 0 > $lxc_root/selinux/enforce
333 cat <<EOF > ${lxc_root}/etc/hostname
338 cat <<EOF > ${lxc_root}/etc/sysconfig/network
340 HOSTNAME=$GUEST_HOSTNAME
343 cat <<EOF > $lxc_root/etc/hosts
344 127.0.0.1 localhost $GUEST_HOSTNAME
349 dev_path="${lxc_root}/dev"
352 mknod -m 666 ${dev_path}/null c 1 3
353 mknod -m 666 ${dev_path}/zero c 1 5
354 mknod -m 666 ${dev_path}/random c 1 8
355 mknod -m 666 ${dev_path}/urandom c 1 9
356 mkdir -m 755 ${dev_path}/pts
357 mkdir -m 1777 ${dev_path}/shm
358 mknod -m 666 ${dev_path}/tty c 5 0
359 mknod -m 666 ${dev_path}/tty0 c 4 0
360 mknod -m 666 ${dev_path}/tty1 c 4 1
361 mknod -m 666 ${dev_path}/tty2 c 4 2
362 mknod -m 666 ${dev_path}/tty3 c 4 3
363 mknod -m 666 ${dev_path}/tty4 c 4 4
364 mknod -m 600 ${dev_path}/console c 5 1
365 mknod -m 666 ${dev_path}/full c 1 7
366 mknod -m 600 ${dev_path}/initctl p
367 mknod -m 666 ${dev_path}/ptmx c 5 2
369 if [ "$(echo $fcdistro | cut -d"f" -f2)" -le "14" ]; then
370 fedora_configure_init
372 fedora_configure_systemd
375 guest_ifcfg=${lxc_root}/etc/sysconfig/network-scripts/ifcfg-$VIF_GUEST
376 ( [ -n "$BUILD_MODE" ] && write_guest_ifcfg_build || write_guest_ifcfg_test ) > $guest_ifcfg
378 fedora_configure_yum $lxc $fcdistro $pldistro
383 function fedora_configure_init() {
386 sed -i 's|.sbin.start_udev||' ${lxc_root}/etc/rc.sysinit
387 sed -i 's|.sbin.start_udev||' ${lxc_root}/etc/rc.d/rc.sysinit
388 # don't mount devpts, for pete's sake
389 sed -i 's/^.*dev.pts.*$/#\0/' ${lxc_root}/etc/rc.sysinit
390 sed -i 's/^.*dev.pts.*$/#\0/' ${lxc_root}/etc/rc.d/rc.sysinit
391 chroot ${lxc_root} chkconfig udev-post off
392 chroot ${lxc_root} chkconfig network on
395 # this code of course is for guests that do run on systemd
396 function fedora_configure_systemd() {
399 # so ignore if we can't find /etc/systemd at all
400 [ -d ${lxc_root}/etc/systemd ] || return 0
401 # otherwise let's proceed
402 ln -sf /lib/systemd/system/multi-user.target ${lxc_root}/etc/systemd/system/default.target
403 touch ${lxc_root}/etc/fstab
404 ln -sf /dev/null ${lxc_root}/etc/systemd/system/udev.service
406 # this was intended for f16 initially, in order to enable getty that otherwise would not start
407 # having a getty running is helpful only if ssh won't start though, and we see a correlation between
408 # VM's that refuse to lxc-stop and VM's that run crazy getty's
409 # so, turning getty off for now instead
410 # #dependency on a device unit fails it specially that we disabled udev
411 # sed -i 's/After=dev-%i.device/After=/' ${lxc_root}/lib/systemd/system/getty\@.service
412 ln -sf /dev/null ${lxc_root}/etc/systemd/system/"getty@.service"
413 rm -f ${lxc_root}/etc/systemd/system/getty.target.wants/*service || :
414 # can't seem to handle this one with systemctl
415 chroot ${lxc_root} chkconfig network on
418 # overwrite container yum config
419 function fedora_configure_yum () {
429 chroot $lxc_root rpm --rebuilddb
431 echo "Initializing yum.repos.d in $lxc"
432 rm -f $lxc_root/etc/yum.repos.d/*
434 cat > $lxc_root/etc/yum.repos.d/building.repo <<EOF
436 name=Fedora $release - $arch
437 baseurl=http://mirror.onelab.eu/fedora/releases/$release/Everything/$arch/os/
441 gpgkey=http://mirror.onelab.eu/keys/RPM-GPG-KEY-fedora-$release-primary
444 name=Fedora $release - $arch - Updates
445 baseurl=http://mirror.onelab.eu/fedora/updates/$release/$arch/
449 gpgkey=http://mirror.onelab.eu/keys/RPM-GPG-KEY-fedora-$release-primary
452 # for using vtest-init-lxc.sh as a general-purpose lxc creation wrapper
453 # just mention 'none' as the repo url
454 if [ -n "$REPO_URL" ] ; then
455 if [ ! -d $lxc_root/etc/yum.repos.d ] ; then
456 echo "WARNING : cannot create myplc repo"
458 # exclude kernel from fedora repos
459 yumexclude=$(pl_plcyumexclude $fcdistro $pldistro $DIRNAME)
460 for repo in $lxc_root/etc/yum.repos.d/* ; do
461 [ -f $repo ] && yumconf_exclude $repo "exclude=$yumexclude"
463 # the build repo is not signed at this stage
464 cat > $lxc_root/etc/yum.repos.d/myplc.repo <<EOF
475 ##############################
476 # need to specify the right mirror for debian variants like ubuntu and the like
477 function debian_mirror () {
480 squeeze|wheezy|jessie)
481 echo http://ftp2.fr.debian.org/debian/ ;;
482 oneiric|precise|quantal|raring|saucy)
483 echo http://mir1.ovh.net/ubuntu/ubuntu/ ;;
484 *) echo unknown distro $fcdistro; exit 1;;
488 function debian_install () {
493 arch=$(canonical_arch $personality $fcdistro)
494 mirror=$(debian_mirror $fcdistro)
495 debootstrap --arch $arch $fcdistro $lxc_root $mirror
496 # just like with fedora we ensure a few packages get installed as well
498 #virsh -c lxc:/// lxc-enter-namespace $lxc /bin/bash -c "apt-get update"
499 #virsh -c lxc:/// lxc-enter-namespace $lxc /bin/bash -c "apt-get -y install $DEBIAN_PREINSTALLED"
500 chroot $lxc_root apt-get update
501 chroot $lxc_root apt-get -y install $DEBIAN_PREINSTALLED
503 cat <<EOF > ${lxc_root}/etc/hostname
509 function debian_configure () {
510 guest_interfaces=${lxc_root}/etc/network/interfaces
511 ( [ -n "$BUILD_MODE" ] && write_guest_interfaces_build || write_guest_interfaces_test ) > $guest_interfaces
514 function write_guest_interfaces_build () {
517 iface $VIF_GUEST inet dhcp
521 function write_guest_interfaces_test () {
524 iface $VIF_GUEST inet static
530 ##############################
531 function setup_lxc() {
535 #trap failure ERR INT
540 personality=$1; shift
542 # create lxc container
544 pkg_method=$(package_method $fcdistro)
547 fedora_install || { echo "failed to install fedora root image"; exit 1 ; }
548 fedora_configure || { echo "failed to configure fedora for a container"; exit 1 ; }
551 debian_install $lxc || { echo "failed to install debian/ubuntu root image"; exit 1 ; }
552 debian_configure || { echo "failed to configure debian/ubuntu for a container"; exit 1 ; }
555 echo "$COMMAND:: unknown package_method - exiting"
560 # Enable cgroup -- xxx -- is this really useful ?
561 mkdir $lxc_root/cgroup
564 cp /etc/resolv.conf $lxc_root/etc/resolv.conf
565 # and /etc/hosts for at least localhost
566 [ -f $lxc_root/etc/hosts ] || echo "127.0.0.1 localhost localhost.localdomain" > $lxc_root/etc/hosts
568 # grant ssh access from host to guest
569 mkdir $lxc_root/root/.ssh
570 cat /root/.ssh/id_rsa.pub >> $lxc_root/root/.ssh/authorized_keys
571 chmod 700 $lxc_root/root/.ssh
572 chmod 600 $lxc_root/root/.ssh/authorized_keys
574 # don't keep the input xml, this can be retrieved at all times with virsh dumpxml
575 config_xml=/tmp/$lxc.xml
576 ( [ -n "$BUILD_MODE" ] && write_lxc_xml_build $lxc || write_lxc_xml_test $lxc ) > $config_xml
578 # define lxc container for libvirt
579 virsh -c lxc:/// define $config_xml
584 function write_lxc_xml_test () {
589 <memory>524288</memory>
591 <type arch='$arch2'>exe</type>
592 <init>/sbin/init</init>
598 <clock offset='utc'/>
599 <on_poweroff>destroy</on_poweroff>
600 <on_reboot>restart</on_reboot>
601 <on_crash>destroy</on_crash>
603 <emulator>/usr/libexec/libvirt_lxc</emulator>
604 <filesystem type='mount'>
605 <source dir='$lxc_root'/>
608 <interface type="bridge">
609 <source bridge="$PUBLIC_BRIDGE"/>
610 <target dev='$VIF_HOST'/>
612 <console type='pty' />
615 <name>host-bridge</name>
616 <forward mode="bridge"/>
617 <bridge name="$PUBLIC_BRIDGE"/>
623 function write_lxc_xml_build () {
628 <memory>524288</memory>
630 <type arch='$arch2'>exe</type>
631 <init>/sbin/init</init>
637 <clock offset='utc'/>
638 <on_poweroff>destroy</on_poweroff>
639 <on_reboot>restart</on_reboot>
640 <on_crash>destroy</on_crash>
642 <emulator>/usr/libexec/libvirt_lxc</emulator>
643 <filesystem type='mount'>
644 <source dir='$lxc_root'/>
647 <interface type="network">
648 <source network="default"/>
650 <console type='pty' />
656 # this one is dhcp-based
657 function write_guest_ifcfg_build () {
668 # use fixed GUEST_IP as specified by GUEST_HOSTNAME
669 function write_guest_ifcfg_test () {
674 HOSTNAME=$GUEST_HOSTNAME
684 function devel_or_vtest_tools () {
693 personality=$1; shift
695 pkg_method=$(package_method $fcdistro)
697 pkgsfile=$(pl_locateDistroFile $DIRNAME $pldistro $PREINSTALLED)
699 ### install individual packages, then groups
700 # get target arch - use uname -i here (we want either x86_64 or i386)
702 lxc_arch=$(chroot $lxc_root uname -i)
703 # on debian systems we get arch through the 'arch' command
704 [ "$lxc_arch" = "unknown" ] && lxc_arch=$(chroot $lxc_root arch)
706 packages=$(pl_getPackages -a $lxc_arch $fcdistro $pldistro $pkgsfile)
707 groups=$(pl_getGroups -a $lxc_arch $fcdistro $pldistro $pkgsfile)
709 case "$pkg_method" in
711 [ -n "$packages" ] && chroot $lxc_root yum -y install $packages
712 for group_plus in $groups; do
713 group=$(echo $group_plus | sed -e "s,+++, ,g")
714 chroot $lxc_root yum -y groupinstall "$group"
716 # store current rpm list in /init-lxc.rpms in case we need to check the contents
717 chroot $lxc_root rpm -aq > $lxc_root/init-lxc.rpms
721 if grep -iq ubuntu /vservers/$lxc/etc/lsb-release 2> /dev/null; then
722 # on ubuntu, at this point we end up with a single feed in /etc/apt/sources.list
723 # we need at least to add the 'universe' feed for python-rpm
724 ( cd /vservers/$lxc/etc/apt ; head -1 sources.list | sed -e s,main,universe, > sources.list.d/universe.list )
725 # also adding a link to updates sounds about right
726 ( cd /vservers/$lxc/etc/apt ; head -1 sources.list | sed -e 's, main,-updates main,' > sources.list.d/updates.list )
728 for package in $packages ; do
729 # container not started yet
730 #virsh -c lxc:/// lxc-enter-namespace $lxc /bin/bash -c "apt-get install -y $package" || :
731 chroot $lxc_root apt-get install -y $package || :
733 ### xxx todo install groups with apt..
736 echo "unknown pkg_method $pkg_method"
743 function post_install () {
745 personality=$1; shift
746 if [ -n "$BUILD_MODE" ] ; then
747 post_install_build $lxc $personality
748 virsh -c lxc:/// start $lxc
749 # manually run dhclient in guest - somehow this network won't start on its own
750 virsh -c lxc:/// lxc-enter-namespace $lxc /bin/bash -c "dhclient $VIF_GUEST"
752 post_install_myplc $lxc $personality
753 virsh -c lxc:/// start $lxc
754 # it sounds like we don't need ssh per se any more
755 # it still makes sense to wait for network readiness though
759 # setup localtime from the host
760 cp /etc/localtime $lxc_root/etc/localtime
763 function post_install_build () {
770 personality=$1; shift
772 ### From myplc-devel-native.spec
773 # be careful to backslash $ in this, otherwise it's the root context that's going to do the evaluation
774 cat << EOF | chroot $lxc_root bash -x
776 # customize root's prompt
777 /bin/cat << PROFILE > /root/.profile
778 export PS1="[$lxc] \\w # "
785 function post_install_myplc () {
791 personality=$1; shift
793 # be careful to backslash $ in this, otherwise it's the root context that's going to do the evaluation
794 cat << EOF | chroot $lxc_root bash -x
796 # create /etc/sysconfig/network if missing
797 [ -f /etc/sysconfig/network ] || /bin/echo NETWORKING=yes > /etc/sysconfig/network
799 # turn off regular crond, as plc invokes plc_crond
800 /sbin/chkconfig crond off
802 # customize root's prompt
803 /bin/cat << PROFILE > /root/.profile
804 export PS1="[$lxc] \\w # "
810 function wait_for_ssh () {
813 #trap failure ERR INT
817 echo network in guest is up, waiting for ssh...
819 #wait max 2 min for sshd to start
821 current_time=$(date +%s)
822 stop_time=$(($current_time + 120))
825 while [ "$current_time" -lt "$stop_time" ] ; do
826 echo "$counter-th attempt to reach sshd in container $lxc ..."
827 ssh -o "StrictHostKeyChecking no" $GUEST_IP 'uname -i' && { ssh_up=true; echo "SSHD in container $lxc is UP"; break ; } || :
829 current_time=$(($current_time + 10))
830 counter=$(($counter+1))
833 # Thierry: this is fatal, let's just exit with a failure here
834 [ -z $ssh_up ] && { echo "SSHD in container $lxc is not running" ; exit 1 ; }
839 function failure () {
840 echo "$COMMAND : Bailing out"
846 echo "Usage: $COMMAND [options] lxc-name (aka build mode)"
847 echo "Usage: $COMMAND -n hostname [options] lxc-name (aka test mode)"
849 echo " This command creates a fresh lxc instance, for building, or running a test myplc"
850 echo "In its first form, spawned VM gets a private IP bridged with virbr0 over dhcp/nat"
851 echo "With the second form, spawned VM gets a public IP bridged on public bridge br0"
853 echo "Supported options"
854 echo " -n hostname - the hostname to use in container"
855 echo " -f fcdistro - for creating the root filesystem - defaults to $DEFAULT_FCDISTRO"
856 echo " -d pldistro - defaults to $DEFAULT_PLDISTRO - current support for fedoras debians ubuntus"
857 echo " -p personality - defaults to $DEFAULT_PERSONALITY"
858 echo " -r repo-url - used to populate yum.repos.d - required in test mode"
859 echo " -P pkgs_file - defines a set of extra packages to install in guest"
860 echo " by default we use devel.pkgs (build mode) or runtime.pkgs (test mode)"
861 echo " -v be verbose"
869 #trap failure ERR INT
871 if [ "$(id -u)" != "0" ]; then
872 echo "This script should be run as 'root'"
876 while getopts "n:f:d:p:r:P:v" opt ; do
878 n) GUEST_HOSTNAME=$OPTARG;;
879 f) fcdistro=$OPTARG;;
880 d) pldistro=$OPTARG;;
881 p) personality=$OPTARG;;
882 r) REPO_URL=$OPTARG;;
883 P) PREINSTALLED=$OPTARG;;
884 v) VERBOSE=true; set -x;;
889 shift $(($OPTIND - 1))
891 # parse fixed arguments
892 [[ -z "$@" ]] && usage
894 lxc_root=/vservers/$lxc
896 almost_empty $lxc_root || \
897 { echo "container $lxc already exists in $lxc_root - exiting" ; exit 1 ; }
898 virsh -c lxc:/// domuuid $lxc >& /dev/null && \
899 { echo "container $lxc already exists in libvirt - exiting" ; exit 1 ; }
902 # check we've exhausted the arguments
903 [[ -n "$@" ]] && usage
905 # BUILD_MODE is true unless we specified a hostname
906 [ -n "$GUEST_HOSTNAME" ] || BUILD_MODE=true
909 [ -z "$fcdistro" ] && fcdistro=$DEFAULT_FCDISTRO
910 [ -z "$pldistro" ] && pldistro=$DEFAULT_PLDISTRO
911 [ -z "$personality" ] && personality=$DEFAULT_PERSONALITY
913 # the set of preinstalled packages - depends on mode
914 if [ -z "$PREINSTALLED"] ; then
915 if [ -n "$BUILD_MODE" ] ; then
916 PREINSTALLED=devel.pkgs
918 PREINSTALLED=runtime.pkgs
922 if [ -n "$BUILD_MODE" ] ; then
923 # we can now set GUEST_HOSTNAME safely
924 [ -z "$GUEST_HOSTNAME" ] && GUEST_HOSTNAME=$(echo $lxc | sed -e 's,\.,-,g')
926 # as this command can be used in other contexts, not specifying
927 # a repo is considered a warning
928 # use -r none to get rid of this warning
929 if [ "$REPO_URL" == "none" ] ; then
931 elif [ -z "$REPO_URL" ] ; then
932 echo "WARNING -- setting up a yum repo is recommended"
937 release=$(echo $fcdistro | cut -df -f2)
939 if [ "$personality" == "linux32" ]; then
942 elif [ "$personality" == "linux64" ]; then
946 echo "Unknown personality: $personality"
949 # compute networking details for the test mode
950 # (build mode relies entirely on dhcp on the private subnet)
951 if [ -z "$BUILD_MODE" ] ; then
953 create_bridge_if_needed
955 GUEST_IP=$(gethostbyname $GUEST_HOSTNAME)
956 # use same NETMASK as bridge interface br0
957 MASKLEN=$(ip addr show $PUBLIC_BRIDGE | grep -v inet6 | grep inet | awk '{print $2;}' | cut -d/ -f2)
958 NETMASK=$(masklen_to_netmask $MASKLEN)
959 GATEWAY=$(ip route show | grep default | awk '{print $3}' | head -1)
960 VIF_HOST="i$(echo $GUEST_HOSTNAME | cut -d. -f1)"
963 setup_lxc $lxc $fcdistro $pldistro $personality
965 devel_or_vtest_tools $lxc $fcdistro $pldistro $personality
967 # container gets started here
968 post_install $lxc $personality